<style lang="less">
@import '@/assets/css/vars';
.Photobox {
    display: flex;
    flex-flow: row nowrap;
    align-items: stretch;
    justify-content: center;

    &__next,
    &__prev {
        flex: 0 1 210px;
        button {
            background: none;
            cursor: pointer;
            max-width: 70px;
            text-align: left;
            display: block;
            height: 100%;
            font-size: 48px;
            padding: 0;
            margin: 0 auto;
            border: 0;
            &:hover,
            &:active {
                color: @color-darkblue;
            }
            &[disabled] {
                background: none;
                color: gray;
            }
        }
    }

    &__prev {
        button {
            transform: rotate(180deg);
        }
    }

    &__stripe {
        flex: 0 1 @section-max-width;
        height: 236px;
        overflow: hidden;
        & > div {
            width: 100%;
            height: 100%;
            overflow: hidden;
            overflow-x: scroll;
            scroll-behavior: smooth;
            &::-webkit-scrollbar {display: none}
            -ms-overflow-style: none;
            scrollbar-width: none;
            & > ul {
                &, & > li {
                    padding: 0;
                    margin: 0;
                    list-style: none;
                    height: 100%;
                }
                width: 100%;
                padding: 0;
                display: flex;
                flex-flow: row nowrap;
                & > li {
                    flex: 0 0 auto;
                    box-sizing: border-box;
                    width: calc((100% - 60px) / 3);
                    margin-right: 30px;
                    overflow: hidden;
                }
                picture {
                    display: block;
                    width: 100%;
                    height: 100%;
                    object-fit: cover;
                }
            }
        }
    }
}
</style>

<template>
<div class="Photobox">
    <div class="Photobox__prev">
        <button type="button" class="icon-right-open"
            aria-label="prev"
            :disabled='disabledPrev ? "" : null'
            @click='scrollX(-1)'/>
    </div>
    <div class="Photobox__stripe">
        <div ref='stripe'>
            <ul ref='ul'>
                <li v-for='a, k in Array(8)' :key='k'>
                    <photo :src='`img/photos/${k%3}.jpg`' width="450" height="236"/>
                </li>
            </ul>
        </div>
    </div>
    <div class="Photobox__next">
        <button type="button" class="icon-right-open"
            aria-label="next"
            :disabled='disabledNext ? "" : null'
            @click='scrollX(+1)'/>
    </div>
</div>
</template>

<script lang="ts">
import {Vue, Options} from '@/vue';
@Options<Photobox>({
    mounted() {
        const stripe = this.$refs.stripe as HTMLDivElement;
        const bodyer = stripe.firstElementChild as HTMLDivElement;
        const ul = this.$refs.ul as HTMLDivElement;
        const stripeWidth = stripe.offsetWidth;

        // const scrollSize = stripe.offsetHeight - stripe.clientHeight;
        // if (scrollSize !== 17) stripe.style.marginBottom = `-${scrollSize}px`;

        this.scrollSize = stripeWidth / 2;
        this.scrollDiv = stripe;
        this.bodyerDiv = bodyer;

        if (ul) {
            const domObserver = new MutationObserver((mr: MutationRecord[]) => this.scrollX(null));
            domObserver.observe(ul, {childList: true});
            this.domObserver = domObserver;
        }

        this.onresizeCallback = this.onresize.bind(this);
        window.addEventListener('resize', this.onresizeCallback);
        this.scrollDiv.addEventListener('scroll', this.onScroll);

        this.scrollX(null);
        this.onresizeCallback();
    },
    beforeUnmount() {
        if (this.domObserver) this.domObserver.disconnect();
        window.removeEventListener('resize', this.onresizeCallback);
        this.scrollDiv.removeEventListener('scroll', this.onScroll);
    },
})
export default class Photobox extends Vue {
    scroll(dir:number = 1) {
        const stripe = this.$refs.stripe as HTMLElement;
        const w = stripe.offsetWidth;
        const x = stripe.scrollLeft;
        stripe.scrollLeft = x + w * dir;
    }
    scrollSize: number = 0;
    scrollDiv!: HTMLDivElement;
    bodyerDiv!: HTMLDivElement;
    domObserver!: MutationObserver;
    scrollable: boolean = false;
    onresizeCallback?: any;
    onresize() {
        const overflow = this.scrollDiv.offsetWidth < this.bodyerDiv.offsetWidth;
        if (this.scrollable !== overflow) this.scrollable = overflow;

        const sc = this.scrollDiv;
        this.disabledPrev = sc.scrollLeft <= 0;
        this.disabledNext = 0 >= (sc.scrollWidth - sc.offsetWidth - sc.scrollLeft);
    }

    disabledPrev: boolean = true;
    disabledNext: boolean = true;
    scrollX(dir: number | null) {
        if (!this.scrollDiv) return;
        const stripe = this.scrollDiv;

        let scrollLeft = (dir === null) ? 0 : stripe.scrollLeft + (dir * this.scrollSize);
        if (this.disabledNext && dir === -1) scrollLeft -= 1;
        if (this.disabledPrev && dir === 1) scrollLeft += 1;
        if (scrollLeft < 5) scrollLeft = 0;
        stripe.scrollLeft = scrollLeft;

        this.disabledPrev = scrollLeft <= 0;
        this.disabledNext = 0 >= (stripe.scrollWidth - stripe.offsetWidth - scrollLeft);
    }

    timeout:number = 0;
    onScroll() { // disable buttons on scroll
        window.clearTimeout(this.timeout);
        this.timeout = window.setTimeout(() => this.scrollX(0), 250);
    }

}
</script>
